OUTPUT_FORMAT("elf32-z80", "elf32-z80", "elf32-z80")
OUTPUT_ARCH(z80)
ENTRY(_start)
SECTIONS
{
    .text 0x0000 :
    {
        /* make fallback entry point address,
                _start from your code will override it */
        PROVIDE(_start = .);
        KEEP (*(SORT_NONE(_HEADER)))
        KEEP (*(SORT_NONE(_GSINIT)))
        KEEP (*(SORT_NONE(_GSFINAL)))
        *(_HOME)
        *(_CODE)
        /* set proper ELF flags for section */
        *(.text .stub .text.* .gnu.linkonce.t.*)
        s__INITIALIZER = .;
        KEEP(*(SORT_NONE(_INITIALIZER)))
        l__INITIALIZER = . - s__INITIALIZER;
        __text_end = .;
    }
    .data :
    {
        __data_start = .;
        s__INITIALIZED = .;
        KEEP(*(SORT_NONE(_INITIALIZED)))
        /* set proper ELF flags for section */
        *(.data .data.* .gnu.linkonce.d.*)
        __data_end = .;
    }
    .bss :
    {
        __bss_start = .;
        *(_DATA)
        /* set proper ELF flags for section */
        *(.bss .bss.* .gnu.linkonce.b.*)
        __bss_end = .;
    }
}