/*
 * io.c
 *
 *  Created on: 12. 3. 2020
 *      Author: ladmanj
 */

#include "sdcc.h"

void putDebugChar (int ch);
int getDebugChar (void);
void supetest();

void io_init (void) __naked
{
	__asm__("	jp SET_AY_PORTS");
}
#pragma save
#pragma disable_warning 85
void putDebugChar (int ch) __naked
{
	__asm__(
"	ld	hl, #2+0											\n"\
"	add	hl, sp                                              \n"\
"	ld	a, (hl)		; data k odvysilani z argumentu         \n"\
"	di				; nesmí být zpomalováno a přerušováno   \n"\
"	jp SSAVE_AY_R										    \n"
	);
}
#pragma restore

#pragma save
#pragma disable_warning 59
int getDebugCharNonBlock (void)
{
	__asm__(
"	di				; nesmí být zpomalováno a přerušováno 	\n"\
"	call SLOAD_AY_R	; vraci byte v A, NC asi timeout	  	\n"\
"	ld	hl,#-1		; navratova hodnota pri timeoutu	  	\n"\
"	ret	nc												  	\n"\
"	ld	h,#0											  	\n"\
"	ld	l,a			; nizsi byte navratove hodnoty = data 	\n"
	);
	__fake_return 0;
}
#pragma restore

int getDebugChar (void)
{
	int ch;
	do{
		ch = getDebugCharNonBlock();
	} while(ch<0);
	return ch;
}

void puts(char *s)
{
	while(*s)
		putDebugChar(*s++);
	putDebugChar('\n');
}


void main ()
{
	supetest();
	__asm__(
"	ei		\n"\
"	halt	\n"\
	);
}

void supetest()
{
	__asm__(
"	ld      b,0         \n"\
"loop_st:               \n"\
"	ld      a,b         \n"\
"	out     (254),a     \n"\
"	inc     b           \n"\
"	                    \n"\
"	xor     a           \n"\
"	in      a,(254)     \n"\
"	cpl                 \n"\
"	and     0b00011111  \n"\
"	jp      z,loop_st	\n"
	);
}
